package date

import (
  . "fmt"
  . "gokurs/obj"
)

// Mit x ist immer das aufrufende Datum gemeint.
// Unter einem "leeren" Datum wird ein undefiniertes Datum verstanden,
// repräsentiert durch eine leere Zeichenkette.

type
  Date interface { // Kalenderdaten

  Object
  Stringer

// Liefert ein leeres Datum.  
// New() *Imp

// Liefert (Tag, Monat, Jahr) von x.
  Get() (uint, uint, uint)

// x ist das auf x vorher folgende Datum.
  Next()

// TODO: Formate

// x ist das durch (Tag, Monat, Jahr) definierte Datum,
// wenn das sinnvoll ist; andernfalls ist x leer.
  Set (Tag, Monat, Jahr uint) // error
}
