package intseq

import
  . "gokurs/obj"
type (
  cell struct {
      content int
         next,
         prev *cell
              }
  sequence struct {
      anchor,
         act *cell
         num,
         pos uint
             }
)

func New() *sequence {
  x:= new (sequence)
  c:= new (cell)
//  c.content = 0 // belanglos
  c.next, c.prev = c, c
  x.anchor, x.act = c, c
// x.pos, x.num = 0, 0
  return x
}

func (x *sequence) imp (Y Any) *sequence {
  y, ok:= Y.(*sequence)
  if ! ok { panic("Typfehler") }
  return y
}

func (x *sequence) Empty() bool {
  return x.anchor.next == x.anchor
}

func (x *sequence) Clr() {
  x.anchor.next, x.anchor.prev = x.anchor, x.anchor
  x.act = x.anchor
  x.pos, x.num = 0, 0
}

func (x *sequence) Eq (Y Any) bool {
  y:= x.imp(Y)
  if x.num != y.num { return false }
  return false // TODO
}

func (x *sequence) Copy (Y Any) {
// TODO
}

func (x *sequence) Clone() Any {
  y:= New()
  y.Copy (x)
  return y
}

func (x *sequence) Less (Y Any) bool {
  y:= x.imp(Y)
  if x.num >= y.num { return false }
  return false // TODO
}

func (x *sequence) Num () uint {
  return x.num
}

func (x *sequence) Ins (i int) {
  c:= new (cell)
  c.content = i
  c.next, c.prev = x.act, x.act.prev
  x.act.prev = c
  c.prev.next = c
  x.pos ++
  x.num ++
}

func (x *sequence) Pos () uint {
/*
  c:= x.anchor.next
  var p uint
  for c != x.act {
    p ++
    c = c.next
  }
  return p
*/
  return x.pos
}

func (x *sequence) Put (i int) {
  if x.act == x.anchor {
    panic ("Pre bei seq.Put verletzt")
  }
  x.act.content = i
}

func (x *sequence) SetPos (p uint) {
  if p >= x.num { panic ("Pre bei seq.SetPos verletzt") }
  switch p {
  case 0:
    x.act = x.anchor.next
  case x.num:
    x.act = x.anchor
  case x.pos:
    //
  case x.pos - 1:
    x.act = x.act.prev
  case x.pos + 1:
    x.act = x.act.next
  default:
    n:= p
    for x.act = x.anchor.next; n > 0; n -- {
      x.act = x.act.next
    }
  }
  x.pos = p
}

func (x *sequence) Trav (f mapfunc) {
  for c:= x.anchor.next; c != x.anchor; c = c.next {
    c.content = f (c.content)
  }
}
