package obj

type
  Object interface {

  Equaler  // s. obj/equaler.go
  Comparer // s. obj/comparer.go
  Clearer  // s. obj/clearer.go
}

// Liefert genau dann true, wenn der Typ von a atomar ist.
func Atomic (a Any) bool {
  switch a.(type) {
  case bool,
       int8,  int16,  int32,  int,  int64,
       uint8, uint16, uint32, uint, uint64,
       float32, float64, complex64, complex128,
       string, []byte: // Wir behandeln auch diese beiden als atomare Typen.
    return true
  }
  return false
}

// Liefert genau dann true, wenn der Typ von a das interface Object implementiert.
func IsObject (a Any) bool {
  _, ok:= a.(Object)
  return ok
}

// Liefert genau dann true, wenn a atomar ist oder Object implementiert.
func AtomicOrObject (a Any) bool {
  return Atomic (a) || IsObject (a)
}
