package seq

import (
  . "gokurs/obj"
)
type (
  cell struct {
      content Any
         next,
         prev *cell
              }
  sequence struct {
           anchor,
              act *cell
              num,
              pos uint
                  }
)

func New (a Any) *sequence {
  x:= new (sequence)
  x.anchor = new (cell)
  x.anchor.content = Clone (a)
  x.anchor.next, x.anchor.prev = x.anchor, x.anchor
  x.act = x.anchor
// x.pos, x.num = 0, 0
  return x
}

func (x *sequence) Empty() bool {
  return x.anchor.next == x.anchor
}

func (x *sequence) Clr() {
  x.anchor.next, x.anchor.prev = x.anchor, x.anchor
  x.act = x.anchor
  x.pos, x.num = 0, 0
}

func (x *sequence) Eq (Y Any) bool {
  y:= Y.(*sequence)
  if x.num != y.num { return false }
  for c, c1:= x.anchor.next, y.anchor.next; c != x.anchor; c, c1 = c.next, c1.next {
    if ! c.content.(Object).Eq (c1.content.(Object)) {
      return false
    }
  }
  return true
}

func (x *sequence) ins (a Any) {
  c:= new (cell)
  c.content = Clone(a)
  c.next, c.prev = x.act, x.act.prev
  x.act.prev.next = c
  x.act.prev = c
}

func (x *sequence) Copy (Y Any) {
  y:= Y.(*sequence)
  x.Clr()
  x.anchor.content = Clone (y.anchor.content)
  for l:= y.anchor.next; l != y.anchor; l = l.next {
    x.ins (l.content)
  }
  x.num, x.pos = y.num, y.num
}

func (x *sequence) Clone() Any {
  y:= New (x.anchor.content)
  y.Copy (x)
  return y
}

func (x *sequence) Less (Y Any) bool {
  y:= Y.(*sequence)
  if x.num >= y.num { return false }
  c:= x.anchor.next
  c1:= y.anchor.next
  for c != x.anchor {
    for {
      if c1 == y.anchor {
        return false
      }
      if Eq (c.content, c1.content) {
        c1 = c1.next
        break
      }
      c1 = c1.next
    }
    c = c.next
  }
  return true
}

func (x *sequence) Num() uint {
  return x.num
}

func (x *sequence) Ins (a Any) {
  if ! TypeEq (x.anchor.content, a) { panic ("") }
  x.ins (a)
  x.num ++
  x.pos ++
}

func (x *sequence) Pos() uint {
  return x.pos
}

func (x *sequence) Put (y Any) {
  if x.act == x.anchor {
    panic ("Pre bei seq.Put verletzt")
  }
  x.act.content = Clone (y)
}

func (x *sequence) Seek (p uint) {
  if p > x.num { panic ("Pre bei seq.SetPos verletzt") }
  switch p {
  case 0:
    x.act = x.anchor.next
  case 1:
    x.act = x.anchor.next.next
  case x.num:
    x.act = x.anchor
  case x.num - 1:
    x.act = x.anchor.prev
  case x.pos:
    //
  case x.pos - 1:
    x.act = x.act.prev
  case x.pos + 1:
    x.act = x.act.next
  default:
    n:= p
    for x.act = x.anchor.next; n > 0; n -- {
      x.act = x.act.next
    }
  }
  x.pos = p
}

func (x *sequence) Trav (f Func) {
  for c:= x.anchor.next; c != x.anchor; c = c.next {
    c.content = f (c.content)
  }
}

func (x *sequence) Ex (a Any /* , eq Rel */) bool {
// TODO type check of a
  p:= uint(0)
  for c:= x.anchor.next; c != x.anchor; c = c.next {
    if Eq (a, c.content) {
      x.act, x.pos = c, p
      return true
    }
    p++
  }
  return false
}

func (x *sequence) Get() Any {
  if x.act == x.anchor { return nil } // triviale Ausnahmebehandlung
  return Clone (x.act.content)
}

func (x *sequence) Del() Any {
  if x.act == x.anchor { return nil } // triviale Form von Ausnahmebehandlung
  c:= x.act
  c.next.prev = c.prev
  c.prev.next = c.next
  x.act = c.next
  x.num --
  return Clone (x.act.content)
}

/*
func (x *sequence) Del() Any {
  if x.act == x.anchor { return nil } // triviale Form von Ausnahmebehandlung
  tmp:= x.act
  c:= tmp.next
  x.act.prev.next = c
  c.prev = x.act.prev
  x.act.prev, x.act.next = nil, nil
  x.act = c
  x.num --
  return Clone (tmp.content)
}
*/

func (x *sequence) Filter (Y Sequence, p Pred) {
  for c:= x.anchor.next; c != x.anchor; c = c.next {
    if p (c.content) {
      Y.Ins (c.content)
    }
  }
}

/*
func (x *Imp) Filter (Y Iterator, p Pred) {
  y:= x.imp (Y)
  if y == x { return }
  y.Clr ()
  for l:= x.anchor.next; l != x.anchor; l = l.next {
    if p (l.content) {
      y.ins (l.content)
      y.num ++
    }
  }
  y.pos = x.num
}
*/
